// 2007 Shengalts Aleksander aka Instructor (Shengalts@mail.ru)

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commdlg.h>
#include <commctrl.h>
#include "Resources\resource.h"


//Defines
#define STRID_START     0
#define STRID_COMMAND   1
#define STRID_TIMELOAD  2
#define STRID_TERMINATE 3
#define STRID_CLOSE     4
#define STRID_SAVE      5
#define STRID_CLEAR     6
#define STRID_FILTER    7

#define LVI_CMDLINE    0
#define LVI_TIMELOAD   1

#define APPTIMELOADA   "AppTimeLoad 1.3"
#define APPTIMELOADW  L"AppTimeLoad 1.3"

//Functions prototypes
LRESULT CALLBACK DialogProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DialogProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
int GetTimeLoadA(char *pCmdLine, BOOL bTerminate);
int GetTimeLoadW(wchar_t *wpCmdLine, BOOL bTerminate);
void SaveListA(HWND hWnd);
void SaveListW(HWND hWnd);
BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc);
char* GetLangStringA(LANGID wLangID, int nStringID);
wchar_t* GetLangStringW(LANGID wLangID, int nStringID);

//Global variables
HINSTANCE hInstance;
HICON hDialogIcon;
HWND hAppTimeLoadDlg;
BOOL bOldWindows;
LANGID wLangSystem;
HMENU hMenuList;
RECT rcDialog;
char szCmdLine[32768];
wchar_t wszCmdLine[32768];
char szBuf[MAX_PATH];
wchar_t wszBuf[MAX_PATH];

void _WinMain()
{
  if (GetWindowsDirectoryW(NULL, 0))
    bOldWindows=FALSE;
  else
    bOldWindows=TRUE;
  hInstance=GetModuleHandle(NULL);
  wLangSystem=PRIMARYLANGID(GetUserDefaultLangID());

  if (bOldWindows)
  {
    MSG msg;
    BOOL bMsgStatus;

    InitCommonControls();

    hDialogIcon=LoadIconA(hInstance, MAKEINTRESOURCEA(IDI_ICON));

    if (hAppTimeLoadDlg=CreateDialogA(hInstance, MAKEINTRESOURCEA(IDD_LIST), NULL, (DLGPROC)DialogProcA))
      ShowWindow(hAppTimeLoadDlg, SW_SHOW);

    if (hAppTimeLoadDlg)
    {
      while ((bMsgStatus=GetMessageA(&msg, NULL, 0, 0)) && bMsgStatus != -1)
      {
        if (!IsDialogMessageA(hAppTimeLoadDlg, &msg))
        {
          TranslateMessage(&msg);
          DispatchMessageA(&msg);
        }
      }
    }
  }
  else
  {
    MSG msg;
    BOOL bMsgStatus;

    InitCommonControls();

    hDialogIcon=LoadIconW(hInstance, MAKEINTRESOURCEW(IDI_ICON));

    if (hAppTimeLoadDlg=CreateDialogW(hInstance, MAKEINTRESOURCEW(IDD_LIST), NULL, (DLGPROC)DialogProcW))
      ShowWindow(hAppTimeLoadDlg, SW_SHOW);

    if (hAppTimeLoadDlg)
    {
      while ((bMsgStatus=GetMessageW(&msg, NULL, 0, 0)) && bMsgStatus != -1)
      {
        if (!IsDialogMessageW(hAppTimeLoadDlg, &msg))
        {
          TranslateMessage(&msg);
          DispatchMessageW(&msg);
        }
      }
    }
  }
  ExitProcess(0);
}

LRESULT CALLBACK DialogProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndList;
  static HWND hWndCmdLine;
  static HWND hWndStart;
  static HWND hWndTerminate;
  static HWND hWndClose;

  if (uMsg == WM_INITDIALOG)
  {
    LVCOLUMNA lvcA;

    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hDialogIcon);
    hWndList=GetDlgItem(hDlg, IDC_LIST);
    hWndCmdLine=GetDlgItem(hDlg, IDC_CMDLINE);
    hWndStart=GetDlgItem(hDlg, IDC_START);
    hWndTerminate=GetDlgItem(hDlg, IDC_TERMINATE);
    hWndClose=GetDlgItem(hDlg, IDC_CLOSE);

    SetWindowTextA(hDlg, APPTIMELOADA);
    SendMessage(hWndList, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
    SendMessage(hWndTerminate, BM_SETCHECK, BST_CHECKED, 0);
    SetDlgItemTextA(hDlg, IDC_START, GetLangStringA(wLangSystem, STRID_START));
    SetDlgItemTextA(hDlg, IDC_TERMINATE, GetLangStringA(wLangSystem, STRID_TERMINATE));
    SetDlgItemTextA(hDlg, IDC_CLOSE, GetLangStringA(wLangSystem, STRID_CLOSE));

    //Columns
    lvcA.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
    lvcA.pszText=GetLangStringA(wLangSystem, STRID_COMMAND);
    lvcA.cx=253;
    lvcA.iSubItem=LVI_CMDLINE;
    SendMessage(hWndList, LVM_INSERTCOLUMNA, LVI_CMDLINE, (LPARAM)&lvcA);

    lvcA.pszText=GetLangStringA(wLangSystem, STRID_TIMELOAD);
    lvcA.cx=125;
    lvcA.iSubItem=LVI_TIMELOAD;
    SendMessage(hWndList, LVM_INSERTCOLUMNA, LVI_TIMELOAD, (LPARAM)&lvcA);

    //Popup menu
    if (hMenuList=CreatePopupMenu())
    {
      AppendMenuA(hMenuList, MF_STRING, IDM_SAVE, GetLangStringA(wLangSystem, STRID_SAVE));
      AppendMenuA(hMenuList, MF_SEPARATOR, -1, NULL);
      AppendMenuA(hMenuList, MF_STRING, IDM_CLEAR, GetLangStringA(wLangSystem, STRID_CLEAR));
    }
    GetWindowPos(hDlg, NULL, &rcDialog);
  }
  else if (uMsg == WM_GETMINMAXINFO)
  {
    MINMAXINFO *mmi=(MINMAXINFO *)lParam;

    mmi->ptMinTrackSize.x=300;
    mmi->ptMinTrackSize.y=160;
    return 0;
  }
  else if (uMsg == WM_SIZE)
  {
    RECT rcTemplate;
    RECT rcControl;
    int x;
    int y;

    if (lParam)
    {
      GetWindowPos(hDlg, NULL, &rcTemplate);
      x=rcTemplate.right - rcDialog.right;
      y=rcTemplate.bottom - rcDialog.bottom;
      memcpy(&rcDialog, &rcTemplate, sizeof(RECT));

      GetWindowPos(hWndCmdLine, hDlg, &rcControl);
      SetWindowPos(hWndCmdLine, 0, 0, 0, rcControl.right + x, rcControl.bottom, SWP_NOMOVE|SWP_NOZORDER);
      GetWindowPos(hWndStart, hDlg, &rcControl);
      SetWindowPos(hWndStart, 0, rcControl.left + x, rcControl.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      GetWindowPos(hWndList, hDlg, &rcControl);
      SetWindowPos(hWndList, 0, 0, 0, rcControl.right + x, rcControl.bottom + y, SWP_NOMOVE|SWP_NOZORDER);
      GetWindowPos(hWndTerminate, hDlg, &rcControl);
      SetWindowPos(hWndTerminate, 0, rcControl.left, rcControl.top + y, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      GetWindowPos(hWndClose, hDlg, &rcControl);
      SetWindowPos(hWndClose, 0, rcControl.left + x, rcControl.top + y, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      return 0;
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndList)
    {
      POINT pt;
      int nCmd;

      if (lParam == ((UINT)-1))
      {
        pt.x=0;
        pt.y=0;
        ClientToScreen(hWndList, &pt);
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      nCmd=TrackPopupMenu(hMenuList, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hDlg, NULL);
      if (nCmd == IDM_SAVE)
        SaveListA(hWndList);
      else if (nCmd == IDM_CLEAR)
        SendMessage(hWndList, LVM_DELETEALLITEMS, 0, 0);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_START)
    {
      LVITEMA lviA;
      int nIndex;
      int nMilliseconds;
      int nSeconds;
      BOOL bTerminate;

      GetWindowTextA(hWndCmdLine, szCmdLine, 32768);
      bTerminate=SendMessage(hWndTerminate, BM_GETCHECK, 0, 0);
      if ((nMilliseconds=GetTimeLoadA(szCmdLine, bTerminate)) != -1)
      {
        nSeconds=nMilliseconds / 1000;
        nMilliseconds=nMilliseconds % 1000;
        wsprintfA(szBuf, "%u,%03u", nSeconds, nMilliseconds);
      }
      else lstrcpy(szBuf, "error");

      lviA.mask=LVIF_TEXT;
      lviA.pszText=szCmdLine;
      lviA.iItem=0x7FFFFFFF;
      lviA.iSubItem=LVI_CMDLINE;
      nIndex=SendMessage(hWndList, LVM_INSERTITEMA, 0, (LPARAM)&lviA);

      lviA.mask=LVIF_TEXT;
      lviA.pszText=szBuf;
      lviA.iItem=nIndex;
      lviA.iSubItem=LVI_TIMELOAD;
      SendMessage(hWndList, LVM_SETITEMA, 0, (LPARAM)&lviA);

      SendMessage(hWndList, LVM_SCROLL, 0, 0x0FFFFFFF);

      if (SendMessage(hWndCmdLine, CB_FINDSTRINGEXACT, 0, (LPARAM)szCmdLine) == CB_ERR)
        SendMessage(hWndCmdLine, CB_ADDSTRING, 0, (LPARAM)szCmdLine);

      if (!bTerminate) SetForegroundWindow(hDlg);
    }
    else if (LOWORD(wParam) == IDC_CLOSE || LOWORD(wParam) == IDCANCEL)
    {
      PostMessage(hDlg, WM_CLOSE, 0, 0);
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    DestroyMenu(hMenuList);
    DestroyWindow(hAppTimeLoadDlg);
    hAppTimeLoadDlg=NULL;
  }
  else if (uMsg == WM_DESTROY)
  {
    PostQuitMessage(0);
  }
  return 0;
}

LRESULT CALLBACK DialogProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndList;
  static HWND hWndCmdLine;
  static HWND hWndStart;
  static HWND hWndTerminate;
  static HWND hWndClose;

  if (uMsg == WM_INITDIALOG)
  {
    LVCOLUMNW lvcW;

    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hDialogIcon);
    hWndList=GetDlgItem(hDlg, IDC_LIST);
    hWndCmdLine=GetDlgItem(hDlg, IDC_CMDLINE);
    hWndStart=GetDlgItem(hDlg, IDC_START);
    hWndTerminate=GetDlgItem(hDlg, IDC_TERMINATE);
    hWndClose=GetDlgItem(hDlg, IDC_CLOSE);

    SetWindowTextW(hDlg, APPTIMELOADW);
    SendMessage(hWndList, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
    SendMessage(hWndTerminate, BM_SETCHECK, BST_CHECKED, 0);
    SetDlgItemTextW(hDlg, IDC_START, GetLangStringW(wLangSystem, STRID_START));
    SetDlgItemTextW(hDlg, IDC_TERMINATE, GetLangStringW(wLangSystem, STRID_TERMINATE));
    SetDlgItemTextW(hDlg, IDC_CLOSE, GetLangStringW(wLangSystem, STRID_CLOSE));

    //Columns
    lvcW.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
    lvcW.pszText=GetLangStringW(wLangSystem, STRID_COMMAND);
    lvcW.cx=253;
    lvcW.iSubItem=LVI_CMDLINE;
    SendMessage(hWndList, LVM_INSERTCOLUMNW, LVI_CMDLINE, (LPARAM)&lvcW);

    lvcW.pszText=GetLangStringW(wLangSystem, STRID_TIMELOAD);
    lvcW.cx=125;
    lvcW.iSubItem=LVI_TIMELOAD;
    SendMessage(hWndList, LVM_INSERTCOLUMNW, LVI_TIMELOAD, (LPARAM)&lvcW);

    //Popup menu
    if (hMenuList=CreatePopupMenu())
    {
      AppendMenuW(hMenuList, MF_STRING, IDM_SAVE, GetLangStringW(wLangSystem, STRID_SAVE));
      AppendMenuW(hMenuList, MF_SEPARATOR, -1, NULL);
      AppendMenuW(hMenuList, MF_STRING, IDM_CLEAR, GetLangStringW(wLangSystem, STRID_CLEAR));
    }
    GetWindowPos(hDlg, NULL, &rcDialog);
  }
  else if (uMsg == WM_GETMINMAXINFO)
  {
    MINMAXINFO *mmi=(MINMAXINFO *)lParam;

    mmi->ptMinTrackSize.x=300;
    mmi->ptMinTrackSize.y=160;
    return 0;
  }
  else if (uMsg == WM_SIZE)
  {
    RECT rcTemplate;
    RECT rcControl;
    int x;
    int y;

    if (lParam)
    {
      GetWindowPos(hDlg, NULL, &rcTemplate);
      x=rcTemplate.right - rcDialog.right;
      y=rcTemplate.bottom - rcDialog.bottom;
      memcpy(&rcDialog, &rcTemplate, sizeof(RECT));

      GetWindowPos(hWndCmdLine, hDlg, &rcControl);
      SetWindowPos(hWndCmdLine, 0, 0, 0, rcControl.right + x, rcControl.bottom, SWP_NOMOVE|SWP_NOZORDER);
      GetWindowPos(hWndStart, hDlg, &rcControl);
      SetWindowPos(hWndStart, 0, rcControl.left + x, rcControl.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      GetWindowPos(hWndList, hDlg, &rcControl);
      SetWindowPos(hWndList, 0, 0, 0, rcControl.right + x, rcControl.bottom + y, SWP_NOMOVE|SWP_NOZORDER);
      GetWindowPos(hWndTerminate, hDlg, &rcControl);
      SetWindowPos(hWndTerminate, 0, rcControl.left, rcControl.top + y, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      GetWindowPos(hWndClose, hDlg, &rcControl);
      SetWindowPos(hWndClose, 0, rcControl.left + x, rcControl.top + y, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      return 0;
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndList)
    {
      POINT pt;
      int nCmd;

      if (lParam == ((UINT)-1))
      {
        pt.x=0;
        pt.y=0;
        ClientToScreen(hWndList, &pt);
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      nCmd=TrackPopupMenu(hMenuList, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hDlg, NULL);
      if (nCmd == IDM_SAVE)
        SaveListW(hWndList);
      else if (nCmd == IDM_CLEAR)
        SendMessage(hWndList, LVM_DELETEALLITEMS, 0, 0);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_START)
    {
      LVITEMW lviW;
      int nIndex;
      int nMilliseconds;
      int nSeconds;
      BOOL bTerminate;

      GetWindowTextW(hWndCmdLine, wszCmdLine, 32768);
      bTerminate=SendMessage(hWndTerminate, BM_GETCHECK, 0, 0);
      if ((nMilliseconds=GetTimeLoadW(wszCmdLine, bTerminate)) != -1)
      {
        nSeconds=nMilliseconds / 1000;
        nMilliseconds=nMilliseconds % 1000;
        wsprintfW(wszBuf, L"%u,%03u", nSeconds, nMilliseconds);
      }
      else lstrcpyW(wszBuf, L"error");

      lviW.mask=LVIF_TEXT;
      lviW.pszText=wszCmdLine;
      lviW.iItem=0x7FFFFFFF;
      lviW.iSubItem=LVI_CMDLINE;
      nIndex=SendMessage(hWndList, LVM_INSERTITEMW, 0, (LPARAM)&lviW);

      lviW.mask=LVIF_TEXT;
      lviW.pszText=wszBuf;
      lviW.iItem=nIndex;
      lviW.iSubItem=LVI_TIMELOAD;
      SendMessage(hWndList, LVM_SETITEMW, 0, (LPARAM)&lviW);

      SendMessage(hWndList, LVM_SCROLL, 0, 0x0FFFFFFF);

      if (SendMessageW(hWndCmdLine, CB_FINDSTRINGEXACT, 0, (LPARAM)wszCmdLine) == CB_ERR)
        SendMessageW(hWndCmdLine, CB_ADDSTRING, 0, (LPARAM)wszCmdLine);

      if (!bTerminate) SetForegroundWindow(hDlg);
    }
    else if (LOWORD(wParam) == IDC_CLOSE || LOWORD(wParam) == IDCANCEL)
    {
      PostMessage(hDlg, WM_CLOSE, 0, 0);
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    DestroyMenu(hMenuList);
    DestroyWindow(hAppTimeLoadDlg);
    hAppTimeLoadDlg=NULL;
  }
  else if (uMsg == WM_DESTROY)
  {
    PostQuitMessage(0);
  }
  return 0;
}

int GetTimeLoadA(char *pCmdLine, BOOL bTerminate)
{
  STARTUPINFO si={0};
  PROCESS_INFORMATION pi={0};
  int nTimeStart;
  int nTimeEnd;

  si.cb=sizeof(STARTUPINFO);
  GetStartupInfo(&si);

  nTimeStart=GetTickCount();
  if (CreateProcess(NULL, szCmdLine, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
  {
    WaitForInputIdle(pi.hProcess, INFINITE);
    if (bTerminate) TerminateProcess(pi.hProcess, 0);
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
  }
  else return -1;
  nTimeEnd=GetTickCount();

  return nTimeEnd - nTimeStart;
}

int GetTimeLoadW(wchar_t *wpCmdLine, BOOL bTerminate)
{
  STARTUPINFOW siW={0};
  PROCESS_INFORMATION pi={0};
  int nTimeStart;
  int nTimeEnd;

  siW.cb=sizeof(STARTUPINFOW);
  GetStartupInfoW(&siW);

  nTimeStart=GetTickCount();
  if (CreateProcessW(NULL, wpCmdLine, NULL, NULL, FALSE, 0, NULL, NULL, &siW, &pi))
  {
    WaitForInputIdle(pi.hProcess, INFINITE);
    if (bTerminate) TerminateProcess(pi.hProcess, 0);
    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
  }
  else return -1;
  nTimeEnd=GetTickCount();

  return nTimeEnd - nTimeStart;
}

void SaveListA(HWND hWnd)
{
  OPENFILENAMEA ofn={0};
  HANDLE hFile;
  DWORD dwBytesWritten;
  LVITEMA lviA;
  int nIndex=0;

  szBuf[0]='\0';
  ofn.lStructSize  =sizeof(OPENFILENAMEA);
  ofn.hwndOwner    =GetParent(hWnd);
  ofn.hInstance    =hInstance;
  ofn.lpstrFile    =szBuf;
  ofn.lpstrFilter  =GetLangStringA(wLangSystem, STRID_FILTER);
  ofn.nFilterIndex =2;
  ofn.lpstrDefExt  ="txt";
  ofn.nMaxFile     =MAX_PATH;
  ofn.Flags        =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLESIZING|OFN_OVERWRITEPROMPT;

  if (GetSaveFileNameA(&ofn))
  {
    if ((hFile=CreateFileA(szBuf, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE)
    {
      if (WriteFile(hFile, "\xFF\xFE", 2, &dwBytesWritten, NULL))
      {
        while (1)
        {
          lviA.mask=LVIF_TEXT;
          lviA.pszText=szCmdLine;
          lviA.cchTextMax=32768;
          lviA.iItem=nIndex;
          lviA.iSubItem=LVI_CMDLINE;
          if (!SendMessage(hWnd, LVM_GETITEMA, 0, (LPARAM)&lviA)) break;

          MultiByteToWideChar(CP_ACP, 0, szCmdLine, -1, wszCmdLine, 32768);
          if (!WriteFile(hFile, &wszCmdLine, wcslen(wszCmdLine) * sizeof(wchar_t), &dwBytesWritten, NULL))
            break;
          if (!WriteFile(hFile, L"\r\n", 4, &dwBytesWritten, NULL))
            break;

          lviA.mask=LVIF_TEXT;
          lviA.pszText=szBuf;
          lviA.cchTextMax=MAX_PATH;
          lviA.iItem=nIndex;
          lviA.iSubItem=LVI_TIMELOAD;
          if (!SendMessage(hWnd, LVM_GETITEMA, 0, (LPARAM)&lviA)) break;

          MultiByteToWideChar(CP_ACP, 0, szBuf, -1, wszBuf, MAX_PATH);
          if (!WriteFile(hFile, &wszBuf, wcslen(wszBuf) * sizeof(wchar_t), &dwBytesWritten, NULL))
            break;
          if (!WriteFile(hFile, L"\r\n\r\n", 8, &dwBytesWritten, NULL))
            break;

          ++nIndex;
        }
      }
      CloseHandle(hFile);
    }
  }
}

void SaveListW(HWND hWnd)
{
  OPENFILENAMEW ofn={0};
  HANDLE hFile;
  DWORD dwBytesWritten;
  LVITEMW lviW;
  int nIndex=0;

  wszBuf[0]='\0';
  ofn.lStructSize  =sizeof(OPENFILENAMEW);
  ofn.hwndOwner    =GetParent(hWnd);
  ofn.hInstance    =hInstance;
  ofn.lpstrFile    =wszBuf;
  ofn.lpstrFilter  =GetLangStringW(wLangSystem, STRID_FILTER);
  ofn.nFilterIndex =2;
  ofn.lpstrDefExt  =L"txt";
  ofn.nMaxFile     =MAX_PATH;
  ofn.Flags        =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLESIZING|OFN_OVERWRITEPROMPT;

  if (GetSaveFileNameW(&ofn))
  {
    if ((hFile=CreateFileW(wszBuf, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) != INVALID_HANDLE_VALUE)
    {
      if (WriteFile(hFile, "\xFF\xFE", 2, &dwBytesWritten, NULL))
      {
        while (1)
        {
          lviW.mask=LVIF_TEXT;
          lviW.pszText=wszCmdLine;
          lviW.cchTextMax=32768;
          lviW.iItem=nIndex;
          lviW.iSubItem=LVI_CMDLINE;
          if (!SendMessage(hWnd, LVM_GETITEMW, 0, (LPARAM)&lviW)) break;

          if (!WriteFile(hFile, &wszCmdLine, wcslen(wszCmdLine) * sizeof(wchar_t), &dwBytesWritten, NULL))
            break;
          if (!WriteFile(hFile, L"\r\n", 4, &dwBytesWritten, NULL))
            break;

          lviW.mask=LVIF_TEXT;
          lviW.pszText=wszBuf;
          lviW.cchTextMax=MAX_PATH;
          lviW.iItem=nIndex;
          lviW.iSubItem=LVI_TIMELOAD;
          if (!SendMessage(hWnd, LVM_GETITEMW, 0, (LPARAM)&lviW)) break;

          if (!WriteFile(hFile, &wszBuf, wcslen(wszBuf) * sizeof(wchar_t), &dwBytesWritten, NULL))
            break;
          if (!WriteFile(hFile, L"\r\n\r\n", 8, &dwBytesWritten, NULL))
            break;

          ++nIndex;
        }
      }
      CloseHandle(hFile);
    }
  }
}

BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc)
{
  if (GetWindowRect(hWnd, rc))
  {
    rc->right-=rc->left;
    rc->bottom-=rc->top;

    if (!hWndOwner)
    {
      rc->left=0;
      rc->top=0;
    }
    else
    {
      if (!ScreenToClient(hWndOwner, (POINT *)&rc->left))
        return FALSE;
    }
    return TRUE;
  }
  return FALSE;
}


char* GetLangStringA(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_START)
      return "";
    if (nStringID == STRID_COMMAND)
      return "";
    if (nStringID == STRID_TIMELOAD)
      return "  ()";
    if (nStringID == STRID_TERMINATE)
      return "  ";
    if (nStringID == STRID_CLOSE)
      return "";
    if (nStringID == STRID_SAVE)
      return "...";
    if (nStringID == STRID_CLEAR)
      return "";
    if (nStringID == STRID_FILTER)
      return "  (*.txt)\0*.txt\0  (*.*)\0*.*\0\0";
  }
  else
  {
    if (nStringID == STRID_START)
      return "Start";
    if (nStringID == STRID_COMMAND)
      return "Command";
    if (nStringID == STRID_TIMELOAD)
      return "Time load (sec)";
    if (nStringID == STRID_TERMINATE)
      return "Terminate after load";
    if (nStringID == STRID_CLOSE)
      return "Close";
    if (nStringID == STRID_SAVE)
      return "Save...";
    if (nStringID == STRID_CLEAR)
      return "Clear";
    if (nStringID == STRID_FILTER)
      return "Text files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
  }
  return "";
}

wchar_t* GetLangStringW(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_START)
      return L"";
    if (nStringID == STRID_COMMAND)
      return L"";
    if (nStringID == STRID_TIMELOAD)
      return L"  ()";
    if (nStringID == STRID_TERMINATE)
      return L"  ";
    if (nStringID == STRID_CLOSE)
      return L"";
    if (nStringID == STRID_SAVE)
      return L"...";
    if (nStringID == STRID_CLEAR)
      return L"";
    if (nStringID == STRID_FILTER)
      return L"  (*.txt)\0*.txt\0  (*.*)\0*.*\0\0";
  }
  else
  {
    if (nStringID == STRID_START)
      return L"Start";
    if (nStringID == STRID_COMMAND)
      return L"Command";
    if (nStringID == STRID_TIMELOAD)
      return L"Time load (sec)";
    if (nStringID == STRID_TERMINATE)
      return L"Terminate after load";
    if (nStringID == STRID_CLOSE)
      return L"Close";
    if (nStringID == STRID_SAVE)
      return L"Save...";
    if (nStringID == STRID_CLEAR)
      return L"Clear";
    if (nStringID == STRID_FILTER)
      return L"Text files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
  }
  return L"";
}
